#ifndef __PS2_MOUSE_H__
#define __PS2_MOUSE_H__

#include "alt_up_ps2_port.h"

//mouse comamnds
static const int MOUSE_SET_SAMPLE_RATE =0xF3;
static const int MOUSE_RESET =0xFF;
static const int MOUSE_SET_DEFAULT =0xF6;
static const int MOUSE_DISABLE_DATA_REPORTING =0xF5;
static const int MOUSE_ENABLE_DATA_REPORTING =0xF4;

static const int MOUSE_READ_DATA =0xEB;
static const int MOUSE_REQUEST_STATUS =0xE9;
static const int MOUSE_SET_RESOLUTION =0xE8;

//Mouse modes (incomplete list)
static const int MOUSE_STREAM_MODE =0xEA;
static const int MOUSE_REMOTE_MODE =0xF0;

/**
 * @brief Reset the mouse
 *
 * @return \c PS2_SUCCESS on BAT is passed, otherwise \c PS2_ERROR
 **/
extern alt_u8 reset_mouse();
int read();
int read_tmout(const unsigned int );
void write1(int);
void init();

/**
 * @brief Set the operation mode of the mouse
 *
 * @param byte -- the byte representing the mode (see macro
 *                definitions for details)
 * @sa PS/2 Mouse document 
 *
 * @return \c PS2_SUCCESS on receiving acknowledgment
 **/
extern int set_mouse_mode(alt_u8 byte);

extern int read_make_code(alt_u8 *buf);

#endif
